function init()
	ragdolls = FindShapes("ragdoll",true)
	table.sort(ragdolls,ragdollSort)
	
	for i=1, #ragdolls do
		if not GetBool("savegame.mod.plane_seat."..i) then
			bodies = GetFullRagdoll(ragdolls[i])
			for b=1,#bodies do
				Delete(bodies[b])
			end
		end
	end
end

function tick(dt)
	local engines = FindLocations("emit",true) --engines can chop up ragdolls
	for i=1, #ragdolls do
		pos = GetShapeWorldTransform(ragdolls[i]).pos
		for e=1, #engines do
			eTrans = GetLocationTransform(engines[e])
			if VecLength(VecSub(pos,eTrans.pos)) < 2.5 then
				if eTrans.pos[1] > 0 then
					SetInt("level.engines.1.red",100)
				else
					SetInt("level.engines.2.red",100)
				end
				
				SetBodyTransform(GetShapeBody(ragdolls[i]),Transform(Vec(0,5,0),Quat()))
				bodies = GetFullRagdoll(ragdolls[i])
				for b=1,#bodies do
					Delete(bodies[b])
				end
			end
		end
	end
end

function _draw()
	UiFont("bold.ttf",24)
	UiColor(1,0,0)
	for i=1, #ragdolls do
		local x, y, dist = UiWorldToPixel(GetShapeWorldTransform(ragdolls[i]).pos)
		if dist > 0 then
			UiTranslate(x, y)
			UiText(i)
		end
	end
end

function GetFullRagdoll(id) --each ragdoll handle only points to it's head. This function returns a list with all the ragdoll parts, as bodies
	local joints = {}
	local shapeList = {id}
	local returnShapes = {}
	while #shapeList > 0 do
		local shape = table.remove(shapeList,1)
		joints = GetShapeJoints(shape)
		for j=1, #joints do
			local otherShape = GetJointOtherShape(joints[j],shape)
			if not table.contains(returnShapes,otherShape) then --never repeat a shape
				table.insert(shapeList,otherShape)
				table.insert(returnShapes,otherShape)
			end
		end
	end
	
	returnBodies = {}
	--DebugPrint(#returnShapes)
	for i=1, #returnShapes do
		--DebugCross(GetShapeWorldTransform(returnShapes[i]).pos)
		returnBodies[i] = GetShapeBody(returnShapes[i])
	end
	
	return returnBodies
end

function table.contains(table, element)
	for _, value in pairs(table) do
		if value == element then
			return true
		end
	end
	return false
end

function ragdollSort(a, b) 
	local aPos = GetShapeWorldTransform(a).pos
	local bPos = GetShapeWorldTransform(b).pos
	if aPos[3] == bPos[3] then
		return aPos[1] < bPos[1]
	else
		return aPos[3] < bPos[3]
	end
end
