#include "ui.lua"

freeze = true -- plane is frozen on spawn (allows player to setup its viewpoint)

plane_settings = {
    boeing={
        strength=5,
        max_speed=40,
        horizontal_decent_modifier = 0.0005,
        vertical_decent_modifier = 0.0001,
        can_loop=true
    },
    crj200={
        strength=5,
        max_speed=35,
        horizontal_decent_modifier = 0.001,
        vertical_decent_modifier = 0.0005,
        can_loop=true
    },
    cesna172={
        strength=1,
        max_speed=50,
        horizontal_decent_modifier = 0.001,
        vertical_decent_modifier = 0.0005,
        can_loop=true
    },
    unknown={
        strength=1,
        max_speed=50,
        horizontal_decent_modifier = 0.0025,
        vertical_decent_modifier = 0.001,
        can_loop=true
    }
}


strength = 10 -- strenght of hte plane (100 - value ) =  percentage of plane that needs to be destroyed until it no longer flies.
max_speed = 25 -- Speed of plane
horizontal_decent_modifier = 0.0005
vertical_decent_modifier = 0.001
vertical_acceleration_modifier = 0.1
absolute = false
startvoxelCount = 0
spawned = false
body_start_pos = nil
body_start_transform = nil
body_start_angle = nil
body_angular_dive = 0
ui = true
onfloor = false
plane_type = "unknown"
loop = false
dive = 0
dive_applied = 0
keep_momentum = true

keybind_pause_unpause = "p"
keybind_toggle_momentum = "x"
keybind_speed_up = "m"
keybind_speed_down = "n"
keybind_strength_up = "b"
keybind_strength_down = "v"
keybind_toggle_loop = "l"
keybind_dive_angle_up = "h"
keybind_dive_angle_down = "g"
keybind_acceleration_up = "r"
keybind_acceleration_down = "t"

function Generic_rnd(mi, ma)
	return math.random(1000)/1000*(ma-mi) + mi
end

function Generic_rndInt(mi, ma)
	return math.random(mi, ma)
end

function init()
    a = GetPlayerCameraTransform()
    plane = FindBody("plane")
    plane_type = GetTagValue(plane, "plane")
    if plane_type ~= nil and plane_type ~= "" then
        max_speed = plane_settings[plane_type]["max_speed"]
        strength = plane_settings[plane_type]["strength"]
        horizontal_decent_modifier = plane_settings[plane_type]["horizontal_decent_modifier"]
        vertical_decent_modifier = plane_settings[plane_type]["vertical_decent_modifier"]
    else
        plane_type = "unknown"
    end

    speed = 1
    vert_speed = 0
    horz_speed_fall = 0
    maxheight = 30
    absolute = false
    no_momentum = false
    b = FindShape("bby")
    startmass = GetBodyMass(plane)
    wings = FindShapes("wings")

    for i=1,#wings do
        wing = wings[i]
        startvoxelCount = startvoxelCount + GetShapeVoxelCount(wing)
    end

    ui = true
    dive = -(body_angular_dive * math.pi / 180)
end

function tick(dt)
    if ui then
        if InputPressed("esc") or InputPressed("return") or InputPressed("lmb") then
            ui = false
        end

        if InputPressed(keybind_toggle_loop) then
            loop = not loop
        end

        if InputPressed(keybind_toggle_momentum) then
            keep_momentum = not keep_momentum
        end

        if InputPressed(keybind_dive_angle_up) then
            body_angular_dive = body_angular_dive + 1
            dive = -(body_angular_dive * math.pi / 180)
        end

        if InputPressed(keybind_dive_angle_down) then
            body_angular_dive = body_angular_dive - 1
            dive = -(body_angular_dive * math.pi / 180)
        end

        if InputPressed(keybind_speed_up) then
            max_speed = max_speed + (1 / 3.6 / 4.8) * 10
        end
        if InputPressed(keybind_speed_down) then
            max_speed = max_speed - (1 / 3.6 / 4.8) * 10
        end


        if max_speed < 1 then
            max_speed = 1
        end

        if InputPressed(keybind_strength_up) then
            strength = strength + 1
        end
        if InputPressed(keybind_strength_down) then
            strength = strength - 1
        end

        if InputPressed(keybind_acceleration_up) then
            vertical_acceleration_modifier = vertical_acceleration_modifier + 0.1
        end
        if InputPressed(keybind_acceleration_down) then
            vertical_acceleration_modifier = vertical_acceleration_modifier - 0.1
        end

        if vertical_acceleration_modifier < 0.1 then
            vertical_acceleration_modifier = 0.1
        end
        if strength > 100 then
            strength = 100
        elseif strength < 1 then
            strength = 1
        end
    end


    if InputPressed("lmb") and spawned == false then
        body_start_pos = GetBodyTransform(plane)
        body_start_angle = GetBodyAngularVelocity(plane)
        spawned = true
    end

    if InputPressed(keybind_pause_unpause) and spawned then
        freeze = false
    end

    currentvoxelCount = 0
    wings = FindShapes("wings")

    for i=1,#wings do
        wing = wings[i]
        currentvoxelCount = currentvoxelCount + GetShapeVoxelCount(wing)
    end

    if currentvoxelCount < startvoxelCount - (startvoxelCount / 100 * strength) then
        absolute = true
    end

    if currentvoxelCount < startvoxelCount - (startvoxelCount / 100 * (strength * 4)) then
        no_momentum = true
    end
    currentmass = GetBodyMass(plane)
    -- These need to be updated each tick for their new values/positions.
    local planet = GetBodyTransform(plane)
    local trVec = Vec(0, vert_speed, -speed)
    local trVel = TransformToParentPoint(planet, trVec)
    local velSub = VecSub(trVel, planet.pos)
    local bias = Vec(0, 0, 0)
    if freeze then
        velSub = Vec(0,0,0)
        if spawned then
            SetBodyVelocity(plane, velSub)
            SetBodyTransform(plane, body_start_pos)
            -- SetBodyAngularVelocity(plane, body_start_angle)
        end
    else
        if not absolute then
            -- if (planet.pos[2] < maxheight) then
            --     -- bias[2] = speed
            --     speed = speed
            -- end
            local cur_vel = GetBodyVelocity(plane)

            SetBodyVelocity(plane, velSub)
            if loop == false then

                if dive_applied < 60 then
                    body_start_angle[1] = dive
                    local trRotVel = TransformToParentPoint(planet, body_start_angle)
                    body_start_angle = VecSub(trRotVel, planet.pos)
                end
                SetBodyAngularVelocity(plane, body_start_angle)

                if dive_applied >= 60 then
                    body_start_angle[1] = 0
                end
                dive_applied = dive_applied + 1
            else
                body_start_angle[1] = dive * -1
                local trRotVel = TransformToParentPoint(planet, body_start_angle)
                body_start_angle = VecSub(trRotVel, planet.pos)
                SetBodyAngularVelocity(plane, body_start_angle)
            end
            speed = speed + vertical_acceleration_modifier
            if speed > max_speed then
                speed = max_speed
            end
        elseif keep_momentum and no_momentum == false then
            if speed > 3 then
                if (planet.pos[2] < 1) then
                    vert_speed = 0
                    if onfloor == false then
                        onfloor = true
                        horizontal_decent_modifier = horizontal_decent_modifier * 8
                    end
                else
                    if vert_speed <= -max_speed then
                        vert_speed = -max_speed
                    else
                        vert_speed = vert_speed - (vertical_decent_modifier * ((max_speed - speed + 1)/2)^2)
                    end
                end
                SetBodyVelocity(plane, velSub)

                speed = speed - (horizontal_decent_modifier * (-speed/2)^2)
            end
        end

    end

end

function draw()


    local w = 540
    local h = 540
	if ui then
		-- UiMakeInteractive()
		-- SetBool("game.disablepause", true)
        UiTranslate( 30 + w / 2, 30)
        UiAlign("center")
		UiColor(0,0,0,0.7)
		UiImageBox("ui/common/box-solid-10.png", w, h, 10, 10)
		UiWindow(w, h)

		UiPush()
			UiTranslate(UiCenter(), 40)
			UiColor(1,1,1)
			UiFont("bold.ttf", 32)
			UiText("Plane Options For: " .. plane_type)
		UiPop()

		UiTranslate(0, 90)

		UiPush()
			UiFont("regular.ttf", 20)
			UiTranslate(30, 0)
			UiAlign("left")
			UiColor(0.9, 0.9, 0.9)
			UiWordWrap(UiWidth()-60)
			UiText("READ: Configure the plane to be spawned. Press ENTER/ESC or Left Click to place Plane to apply/close menu. Configuration only applies to the current plane and cannot be changed after! See keybinds before each option to change them.")
		UiPop()


		UiTranslate(0, 120)

		UiPush()
			UiTranslate(UiCenter() + 75, 0)
			UiFont("regular.ttf", 14)
			UiColor(1,1,1)
			UiAlign("right")
			UiText("Plane Max Speed (Up: " .. keybind_speed_up .. ") (Down: " .. keybind_speed_down .. "):")
			UiTranslate(10, 0)
			UiAlign("left")
			UiColor(1, 1, 0.5)
			UiText(tostring(max_speed * 3.6 * 4.8) .. " km/h")
		UiPop()

		UiTranslate(0, 48)

		UiPush()
			UiTranslate(UiCenter() + 75, 0)
			UiFont("regular.ttf", 14)
			UiColor(1,1,1)
			UiAlign("right")
            UiText("Plane accelration to max speed: (Up: " .. keybind_acceleration_up .. ") (Down: " .. keybind_acceleration_down .. "):")
			UiTranslate(10, 0)
			UiAlign("left")
			UiColor(1, 1, 0.5)
			UiText(tostring(vertical_acceleration_modifier * 3.6 * 4.8) .. " km/h per frame")
		UiPop()


        UiTranslate(0, 48)

		UiPush()
			UiTranslate(UiCenter() + 75, 0)
			UiFont("regular.ttf", 14)
			UiColor(1,1,1)
			UiAlign("right")
			UiText("Plane Strength (Up: " .. keybind_strength_up .. ") (Down: " .. keybind_strength_down .. "):")
			UiTranslate(10, 0)
			UiAlign("left")
			UiColor(1, 1, 0.5)
			UiText(tostring(strength) .. " %")
		UiPop()


		UiTranslate(0, 48)

		UiPush()
			UiTranslate(UiCenter() + 75, 0)
			UiFont("regular.ttf", 14)
			UiColor(1,1,1)
			UiAlign("right")
            UiText("Plane attempts dive: (Up: " .. keybind_dive_angle_up .. ") (Down: " .. keybind_dive_angle_down .. "):")
			UiTranslate(10, 0)
			UiAlign("left")
			UiColor(1, 1, 0.5)
			UiText(tostring(body_angular_dive) .. " degrees.")
		UiPop()

        if plane_settings[plane_type]["can_loop"] ~= nil then
            UiTranslate(0, 48)
            UiPush()
                UiTranslate(UiCenter() + 75, 0)
                UiFont("regular.ttf", 14)
                UiColor(1,1,1)
                UiAlign("right")
                UiText("Plane attempts barrelrolls: (Toggle: " .. keybind_toggle_loop .. "):")
                UiTranslate(10, 0)
                UiAlign("left")
                UiColor(1, 1, 0.5)
                if loop then
                    UiText("true")
                else
                    UiText("false")
                end
            UiPop()
        end


        UiTranslate(0, 48)
        UiPush()
            UiTranslate(UiCenter() + 75, 0)
            UiFont("regular.ttf", 14)
            UiColor(1,1,1)
            UiAlign("right")
            UiText("Note, applies force after hitting ground")
            UiTranslate(0, 24)
            UiText("Note, turn this off for original (previous version) behavior.")
            UiTranslate(0, 24)
            UiText("Plane keeps realisitic momentum when damaged: (Toggle: " .. keybind_toggle_momentum .. "):")
            UiTranslate(10, 0)
            UiAlign("left")
            UiColor(1, 1, 0.5)
            if keep_momentum then
                UiText("true")
            else
                UiText("false")
            end
        UiPop()
		-- UiTranslate(0, 48)


		-- UiPush()
        --     UiFont("bold.ttf", 20)
        --     UiTranslate(UiCenter() - w / 2 + 40, 0)
        --     UiAlign("left")
        --     UiColor(0.9, 0.9, 0.9)
        --     UiWordWrap(UiWidth()-60)
        --     UiText("The following configuration is applied if plane is damaged beyond " .. tostring(strength) .. "%.")
        -- UiPop()

		-- UiTranslate(0, 48)

		-- UiPush()
        --     UiTranslate(UiCenter() + 75, 0)
        --     UiFont("regular.ttf", 20)
        --     UiColor(1,1,1)
        --     UiAlign("right")
        --     UiText("Vertical Deacceleration(Up: " .. keybind_ver_dec_mf_up .. ") (Down: " .. keybind_ver_dec_mf_down .. "):")
        --     UiTranslate(10, 0)
        --     UiAlign("left")
        --     UiColor(1, 1, 0.5)
        --     UiText(tostring(vertical_decent_modifier))
        -- UiPop()


		-- UiTranslate(0, 48)

		-- UiPush()
        --     UiTranslate(UiCenter() + 75, 0)
        --     UiFont("regular.ttf", 20)
        --     UiColor(1,1,1)
        --     UiAlign("right")
        --     UiText("Horizontal Deacceleration (Up: " .. keybind_hor_dec_mf_up .. ") (Down: " .. keybind_hor_dec_mf_down .. "):")
        --     UiTranslate(10, 0)
        --     UiAlign("left")
        --     UiColor(1, 1, 0.5)
        --     UiText(tostring(horizontal_decent_modifier))
        -- UiPop()
    else
        if freeze then
            UiColor(1, 1, 1)
            UiTranslate(30, 30)
            UiRect(10, 60)
            UiTranslate(40, 0)
            UiRect(10, 60)
            UiColor(1, 0, 0)
            UiTranslate(-40, 90)
            UiFont("regular.ttf", 20)
            UiText("Press '" .. keybind_pause_unpause .."' to start flight!")
        end
    end
end